sábado, 9 de noviembre de 2013

Ejecución remota de código arbitrario en OpenSSH

Se ha anunciado una vulnerabilidad en OpenSSH que podría permitir a un atacante la ejecución de código arbitrario durante la fase de intercambio de llaves entre cliente y servidor.

El fallo fue descubierto por Markus Friedl, uno de los desarrolladores del propio proyecto. Aun no ha sido asignado un CVE.

OpenSSH es una implementación libre de la familia de protocolos SSH, que ofrecen una alternativa segura a los servicios telnet, rlogin, rsh, rcp, ftp y similares. Todo el tráfico entre un servidor SSH y un cliente SSH se realiza de forma cifrada y se aplican fuertes mecanismos para garantizar la autenticación.

El problema reside en una corrupción de memoria en el proceso de post-autenticación cuando se selecciona el cifrado AES-GCM (aes128-gcm@openssh.com o aes256-gcm@openssh.com) durante el intercambio de claves. El problema de seguridad afecta al servidor, el proceso 'sshd'.

El motivo es que cuando se selecciona dicho cifrado, el AES-GCM, el proceso servidor 'sshd' no inicializa correctamente una estructura MAC (Message Authenticacion Code). Dicha estructura contiene punteros a funciones que actuan de "callback" procedentes de un contexto anterior. Al no ser la estructura correctamente inicializada, es decir, limpia de esta información anterior, es posible ejecutar código si se consigue insertar shellcode en ese contexto.

Habrá que estar atentos al exploit. Los creadores de estos tienen un reto por delante, debido en parte a la dificultad de averiguar la dirección a invocar para llegar hasta el código que inyecten en la memoria heap, dirección aleatoria gracias a ASLR (Address-Space Layout Randomization)

El parche es un simple cambio en la función que reserva memoria para la estructura de datos que comentamos. Veamos:

Index: monitor_wrap.c
===================================================================
RCS file: /cvs/src/usr.bin/ssh/monitor_wrap.c,v
retrieving revision 1.76
diff -u -p -u -r1.76 monitor_wrap.c
--- monitor_wrap.c      17 May 2013 00:13:13 -0000      1.76
+++ monitor_wrap.c      6 Nov 2013 16:31:26 -0000
@@ -469,7 +469,7 @@ mm_newkeys_from_blob(u_char *blob, int b
        buffer_init(&b);
        buffer_append(&b, blob, blen);

-       newkey = xmalloc(sizeof(*newkey));
+       newkey = xcalloc(1, sizeof(*newkey));
        enc = &newkey->enc;
        mac = &newkey->mac;
        comp = &newkey->comp;

Tan solo se cambia la llamada a 'xmalloc' por 'xcalloc'. Las funciones de reserva de memoria que comienzan por 'x' permiten "matar" el proceso si no son capaces de reservar la cantidad de memoria que se les pide. No son funciones estándar de la librería del lenguaje C.

El cambio de función permite inicializar la estructura a ceros. Con esta maniobra toda la información que había en el trozo de memoria reservada es "aplastada" ajustando a cero todos sus bits correspondientes. "xmalloc" no lo hace, mantiene la información que hubiera en esa porción de memoria.

Un atacante que logre explotar esta vulnerabilidad podrá conseguir ejecutar código con los privilegios del usuario autenticado.

Se ven afectadas las instalaciones de OpenSSH 6.2 y OpenSSH 6.3 cuando están compiladas con OpenSSL con soporte del cifrado AES-GCM.

Se recomienda actualizar a OpenSSH 6.4 o aplicar el parche antes mencionado, disponible en la alerta:

Como contramedida se puede desactivar AES-GCM en la configuración del servidor. La siguiente opción de "sshd_config" desactivará AES-GCM y deja los otros cifrados activos:

Ciphers aes128-ctr,aes192-ctr,aes256-ctr,aes128-cbc,3des-cbc,blowfish-cbc,cast128-cbc,aes192-cbc,aes256-cbc

Más información:

OpenSSH Security Advisory: gcmrekey.adv



David García
Twitter: @dgn1729



No hay comentarios:

Publicar un comentario en la entrada